% finds simple distances between successive strings stored in a file

function fileiomethod()

% Get input file:
  fclose('all'); % just in case data file is already open
  infile = input('Enter a file that contains strings: ','s');
  while ~exist(infile)
     infile = input('Enter a file that contains strings: ','s');
  end
  data = fopen(infile,'r');

% Get output file:
  outfile = fopen(input('Enter a file to store results: ','s'),'w');

% must assume at least 1 line in file
  line1 = fgetl(data);
  line2 = fgetl(data);

% Gather input strings, compare them, and store in cell array
  ii=0;
  while line2 ~= -1
     ii=ii+1;
 
     % assume all strings good
       strings(ii)={line1}; % store line in a cell array
       strings(ii+1)={line2}; % store line in a cell array

     % report output   
       if length(line1) == length(line2)
          fprintf(outfile,'\n%s%s%s%s%s%s','Hamming distance between ',line1,...
                  ' and ',line2,' is ',num2str(hammingdistance(line1,line2)));
       else
          fprintf(outfile,'\n%s%s%s','No more lines of length ',...
          num2str(length(line1)),'.');
       end
    
     % Gather next input to test
       line1 = line2;         % previous line updated
       line2 = fgetl(data);   % process next line
  end
  fclose('all');
  num_of_str=ii+1;

% Display plot of cell array
  h=cellplot(strings,'Plot of Cell Array');

% Convert cell array to structure array and displays
% - name of cell array:      strings
% - name of structure array: SAstrings
% - fields of structure array are s1,s2,...
%     field si where i is an integer >=1 exists if and only if
%     there are strings of length i in the file 
%     when si exists it contains an array of strings

  pref='s'; % prefix for field of structure
  count=1;  % keeps track of index where the next string is to be stored SA.si
  value=[]; % initial value of SA.si: over time value builds 
            % the array of strings that will be strored in Sa.si

  oldlength=length(strings{1}); % oldlength stores length of previous string
  field=strcat(pref,num2str(length({strings(1)}))); % form field

% Initialize structure array
  SAstrings = 0;

% Create structure array
  for (jj=1:num_of_str) 
     newlength=length(strings{jj});  % get length of current string

     % compare length with previous string 
       if oldlength<newlength                        % current string is longer  
          SAstrings=setfield(SAstrings,field,value); % set previous field to value
          field=strcat(pref,num2str(newlength));     % form next fieldname
          count=1;                                   % init count for empty new field
          oldlength=newlength;                       % set oldlength
          value=[];                                  % initialize value to empty array
       end;

     value=[value;strings{jj}]; % add current string to array value
     count=count+1;             % increment count
  end;

% Remember to set the last field which was not stored in the for loop
  SAstrings=setfield(SAstrings,field,value); 
                                          
% Display sturcture at command prompt
  SAstrings    


