% randommethod : computes and prints hamming and weighted distances 
%         between 2 randomly generated strings
% program chooses a string length randomly between 1 to 100
% program chooses chars A,C,G,T randomly for each position in string

function randommethod()
L = round(99*rand+1); % random number from 1 to 100

nums1 = round(99*rand(1,L)+1);
nums2 = round(99*rand(1,L)+1);
% nums 1 and nums2 are are integer arrays of length L containing 
% random elements between 1 and 100
string1 = pickstring(nums1)
string2 = pickstring(nums2)

fprintf('The hamming distance is %d.\n',    hammingdistance(string1,string2));
fprintf('The weighted distance is %d.\n\n', weighteddistance(string1,string2));

% input:  nums (array containing numbers between 1 and 100)
% output: randomly generated DNA string
function string = pickstring(nums)
   % preallocate string
   chars = zeros(1,length(nums));

% store chars -- use equal ranges so that there is equal distribution
% of A, C , G and T codes
   ii = nums >  0 & nums <=  25; chars(ii)='A';
   ii = nums > 25 & nums <=  50; chars(ii)='C';
   ii = nums > 50 & nums <=  75; chars(ii)='G';
   ii = nums > 75 & nums <= 100; chars(ii)='T';
   % Here ii is a logical array. 
   % chars(ii)=X sets those entries of chars which are true in ii to X
   string = char(chars);
